# Teleport CE Cookbook

Installs the [Gravitational Teleport](https://gravitational.com/teleport) Community Edition (Open source version).

This cookbook has been built following the instructions from https://gravitational.com/teleport/docs/intro/.

This cookbook supports the non-commercial features:
 - Local connector with default `otp` 2FA
 - [Labels](https://gravitational.com/teleport/docs/admin-guide/#labeling-nodes)
 - Session recording and sharing
 - SSH and Kubernetes tunneling

High Availablity not yet implemented, to be done.

## Supported Platforms

* Debian 8/9

_If you want to add more platforms, feel free to open a PR!_

## Recipes

Downloaded archives of Teleport are from https://gravitational.com/teleport/download/.

### teleport-ce::server

Installs the teleport binaries by downloading the `-bin.tar.gz` archive for your linux distribution and architecture.

Then it writes a `/etc/teleport.yaml` file using the attributes defined in `attributes/teleport.rb` and sets [a static token](https://gravitational.com/teleport/docs/admin-guide/#static-tokens) (`tokens` attribute) used by nodes in order to join the cluster.

It also retrieves [the CA pin](https://gravitational.com/teleport/docs/admin-guide/#untrusted-auth-servers) of the server, which will be also used by the nodes in order to join the server, securing even more the connection.

It will also install a systemd unit to start teleport on node's restart, and start the service immediately.

Finally `curl` will be installed in order to wait for Teleport to start requesting its ping API.

### teleport-ce::node

Installs the teleport binaries by downloading the `-bin.tar.gz` archive for your linux distribution and architecture.

Then it writes a `/etc/teleport.yaml` file using the static token, CA pin, and the attributes defined in `attributes/teleport.rb`.

It will also install a systemd unit to start teleport on node's restart, and start the service immediately, so that it will join the node having the `teleport-ce::server` recipe in its `run_list`.

## Attributes

Please look at the `attributes/teleport.rb` file.

## Usage

In order to use this cookbook:

1. Add the cookbook to your chef repository.
2. Add the teleport-ce::server recipe to the node that shall run the teleport daemon (only a single server supported yet).
3. Add the teleport-ce::node recipe to the nodes that shall be a Teleport node
4. Converge ! :)
