# frozen_string_literal: true

#
# Cookbook:: teleport-ce-cookbook
# Recipe:: common
#
# Copyright: 2019, Pharmony SA, All Rights Reserved.
#

# `teleport_archive_filename` in `remote_file`
Chef::Resource::RemoteFile.send(:include, TeleportCookbook::Helper)

# Downloads the Teleport archive
remote_file '/tmp/teleport.tar.gz' do
  action :create
  checksum node['teleport']['sha256']
  mode '0755'
  source "https://get.gravitational.com/#{teleport_archive_filename}"
end

# Extract the teleport executable
ruby_block 'extract and install teleport' do
  action :run
  block do
    shell_out('tar -xvzf /tmp/teleport.tar.gz -C /tmp')
    shell_out('/tmp/teleport/install')
  end
end
